#include<cstdio>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<algorithm>
#include<string>
#include<utility>
#include<cmath>
#include<cstring>
#include<cassert>
#include<iostream>
using namespace std;

#define REP(i,a,b) for(i=a;i<b;i++)
#define rep(i,n) REP(i,0,n)

#define ll long long
#define RAND (rand()/(RAND_MAX+1.0))

ll read_int(ll mn, ll mx, char next){
  int c, fg = 1, res = 0;
  c=getchar();
  if(c=='-') fg = -1, c = getchar();
  assert('0'<=c && c<='9');
  res = c - '0';
  for(;;){
    c = getchar();
    if(c==next) break;
    assert(res!=0);
    assert('0'<=c && c<='9');
    res = res * 10 + (c - '0');
  }
  res *= fg;
  assert(mn<=res && res<=mx);
  return res;
}

int read_string(char a[], int sz_mn, int sz_mx, char next){
  int c, sz = 0;
  for(;;){
    c = getchar();
    if(c==next) break;
    a[sz++] = c;
  }
  a[sz] = '\0';
  assert(sz_mn <= sz && sz <= sz_mx);
  return sz;
}

int read_string2(char a[], int sz_mn, int sz_mx){
  int c, sz = 0;
  char next;
  for(;;){
    c = getchar();
    if(sz==0){
      if(c=='D') next = '\n';
      else       next = ' ';
    }
    if(c==next) break;
    a[sz++] = c;
  }
  a[sz] = '\0';
  assert(sz_mn <= sz && sz <= sz_mx);
  return sz;
}

void charReverse(char d[],int size){int a=0,b=size-1;char t;while(a<b)t=d[a],d[a]=d[b],d[b]=t,a++,b--;}


int str_cmp(char a[], char b[]){
  int i;
  for(i=0;;i++){
    if(a[i]=='\0' && a[i]==b[i]) return 0;
    if(a[i] < b[i]) return 1;
    if(a[i] > b[i]) return -1;
  }
  return -2;
}

int KMP(char longstr[], int longsize, char shortstr[], int shortsize, void *workMemory){
  int i, j, res = 0;
  int *fail = (int*)workMemory;

  j = fail[0] = -1;
  REP(i,1,shortsize+1){
    while(j>=0 && shortstr[j]!=shortstr[i-1]) j = fail[j];
    fail[i] = (++j);
  }

  j = 0;
  rep(i,longsize){
    while(j>=0 && longstr[i]!=shortstr[j]) j = fail[j];
    if((++j) >= shortsize) res++, j=fail[j];
  }

  return res;
}

// node of treap
typedef struct node_hoge{
  struct node_hoge *up, *left, *right, *next;
  double val; double priority;
  char *str; // pointer to raw data of string
  int size;
} NODE;

// treap
typedef struct treap_hoge{
  NODE *root;
} TREAP;

// we can insert only left
typedef struct mystring_hoge{
  char str[400000]; int str_st, str_len; // raw data of string
  NODE *node[400000]; // node[i] = pointer to the node corresponding to the string start from str[i]
  TREAP t;
} MYSTRING;

// we can insert both left and right
typedef struct mystring_hoge2{
  MYSTRING fst, end;
} MYSTRING2;

int reconstruct = 0;
int counter = 1;

NODE* node_create(char *link){
  NODE* res = (NODE*)malloc(sizeof(NODE));
  res->up = res->left = res->right = res->next = NULL;
  res->str = link;
  res->priority = RAND;
  res->size = 1;
  return res;
}

void treap_reconstruct(NODE *node, double mn, double mx){
  node->val = mn + (mx - mn) / 2;
  if(node->left  != NULL) treap_reconstruct(node->left,  mn, node->val);
  if(node->right != NULL) treap_reconstruct(node->right, node->val, mx);
}

void treap_rotate(NODE *todown, NODE *toup){
  NODE *A;

  assert(todown!=toup);

  A = toup->up = todown->up;
  if(A == NULL);
  else if(A->left ==todown) A->left  = toup;
  else if(A->right==todown) A->right = toup;
  else assert(0);

  todown->up = toup;
  if(todown->left == toup) todown->left = toup->right, toup->right = todown;
  else                     todown->right = toup->left, toup->left  = todown;

  if(todown->left != NULL) todown->left->up  = todown;
  if(todown->right!= NULL) todown->right->up = todown;
  if(toup->left != NULL) toup->left->up  = toup;
  if(toup->right!= NULL) toup->right->up = toup;

  todown->size = toup->size = 1;
  if(todown->left  != NULL) todown->size += todown->left->size;
  if(todown->right != NULL) todown->size += todown->right->size;
  if(toup->left  != NULL) toup->size += toup->left->size;
  if(toup->right != NULL) toup->size += toup->right->size;
}

void treap_insert(TREAP *t, NODE *node, double val){
  NODE *cur, *r;
  double leftval = 0, rightval = counter++;

  cur = t->root;
  for(;;){
    if( (node->str[0] < cur->str[0]) || (node->str[0] == cur->str[0] && (cur->next!=NULL && val < cur->next->val)) ){
      rightval = cur->val;
      if(cur->left != NULL){ cur = cur->left; continue; }
      cur->left = node;
    } else {
      leftval = cur->val;
      if(cur->right != NULL){ cur = cur->right; continue; }
      cur->right = node;
    }
    node->up = cur;
    cur->size += node->size;
    node->val = (leftval + rightval) / 2;
    if(rightval < 1e-250 || (rightval-leftval) < rightval * 1e-14) reconstruct = 1;
    assert(node->val != leftval && node->val != rightval);
    break;
  }

  r = node;
  while(r!=NULL){
    r->size = 1;
    if(r->left != NULL) r->size += r->left->size;
    if(r->right!= NULL) r->size += r->right->size;
    r = r->up;
  }

  while(node->up != NULL){
    if(node->priority < node->up->priority) break;
    treap_rotate(node->up, node);
  }
  
  while(t->root->up != NULL) t->root = t->root->up;

  if(reconstruct){
    treap_reconstruct(t->root, 0, counter);
    reconstruct = 0;
  }
}

void treap_delete(TREAP *t, NODE *node){
  NODE *r;
  double pri_left, pri_right;

  if( t->root == node ){
    if(node->left != NULL) t->root = node->left;
    else                   t->root = node->right;
  }

  while(node->left != NULL || node->right != NULL){
    pri_left = pri_right = 0;
    if(node->left  != NULL) pri_left  = node->left->priority;
    if(node->right != NULL) pri_right = node->right->priority;

    if(pri_left > pri_right) treap_rotate(node, node->left);
    else                     treap_rotate(node, node->right);
  }

       if(node->up->left  == node) node->up->left  = NULL;
  else if(node->up->right == node) node->up->right = NULL;
  else assert(0);
  r = node->up;
  free(node);

  while(r!=NULL){
    r->size = 1;
    if(r->left != NULL) r->size += r->left->size;
    if(r->right!= NULL) r->size += r->right->size;
    r = r->up;
  }

  while(t->root->up != NULL) t->root = t->root->up;
}

void mystring_set_1(MYSTRING *s, char c){
  int i;
  s->str_st = 200000;
  s->str_len = 1;
  s->str[s->str_st] = c;

  s->node[s->str_st] = s->t.root = node_create((s->str)+(s->str_st));
  s->t.root->val = 0.5;
}

void mystring_insert_left(MYSTRING *s, char c){
  NODE *node;
  s->str[--(s->str_st)] = c; (s->str_len)++;

  node = node_create((s->str)+(s->str_st));
  treap_insert(&(s->t), node, s->node[(s->str_st)+1]->val);
  while((s->t).root->up != NULL) (s->t).root = (s->t).root->up;

  s->node[s->str_st] = node;
  s->node[s->str_st]->next = s->node[s->str_st + 1];
}

char mystring_delete_left(MYSTRING *s){
  NODE *d = s->node[s->str_st];
  char res = s->str[s->str_st];
  (s->str_st)++; (s->str_len)--;
  treap_delete(&(s->t), d);
  s->node[(s->str_st)-1] = NULL;
  return res;
}

int mystring_get_left_string(MYSTRING *s, int max_len, char res[]){
  int i, len = max_len;
  if(len > s->str_len) len = s->str_len;
  rep(i,len) res[i] = s->str[(s->str_st) + i];
  return len;
}

int mystring_get_right_string(MYSTRING *s, int max_len, char res[]){
  int i, len = max_len;
  if(len > s->str_len) len = s->str_len;
  rep(i,len) res[i] = s->str[(s->str_st) + (s->str_len) - len + i];
  return len;
}

int mystring_count(MYSTRING *s, char c[], int len){
  int k, res = 0;
  NODE *node = (s->t).root;

  c[len] = '\0';
  while(node != NULL){
    k = str_cmp(c, node->str);
    if(k < 0){
      res++;
      if(node->left != NULL) res += node->left->size;
      node = node->right;
    } else {
      node = node->left;
    }
  }

  return res;
}

void mystring_free(MYSTRING *s){
  int i;
  rep(i, s->str_len) free(s->node[s->str_st + i]);
}


MYSTRING2 s1, s2;

int mystring2_get_left_string(MYSTRING2 *s, char res[], int len){
  int i, l1, l2;
  l1 = min(len, s->fst.str_len);
  l2 = min(len-l1, s->end.str_len);

  mystring_get_left_string(&(s->fst), l1, res);
  mystring_get_right_string(&(s->end), l2, res+l1);
  charReverse(res+l1, l2);
  
  return l1 + l2;
}

int mystring2_get_right_string(MYSTRING2 *s, char res[], int len){
  int i, l1, l2;
  l2 = min(len, s->end.str_len);
  l1 = min(len-l2, s->fst.str_len);

  mystring_get_right_string(&(s->fst), l1, res);
  mystring_get_left_string(&(s->end), l2, res+l1);
  charReverse(res+l1, l2);
  
  return l1 + l2;
}

void mystring2_set(MYSTRING2 *s, char a[], int len){
  int i, l1, l2;

  l1 = len / 2;
  l2 = len - l1;

  mystring_set_1(&(s->fst), a[l1-1]);
  rep(i,l1-1) mystring_insert_left(&(s->fst), a[l1-i-2]);
  mystring_set_1(&(s->end), a[l1]);
  rep(i,l2-1) mystring_insert_left(&(s->end), a[l1+1+i]);
}

void mystring2_balance(MYSTRING2 *s){
  static char buf[2000000]; int buf_len;
  buf_len = mystring2_get_left_string(s, buf, 1000000000);
  mystring_free(&(s->fst));
  mystring_free(&(s->end));
  mystring2_set(s, buf, buf_len);
}

void mystring2_insert_left(MYSTRING2 *s, char c){
  mystring_insert_left(&(s->fst), c);
}

void mystring2_insert_right(MYSTRING2 *s, char c){
  mystring_insert_left(&(s->end), c);
}

char mystring2_delete_left(MYSTRING2 *s){
  char res;
  res = mystring_delete_left(&(s->fst));
  if(s->fst.str_len < 2) mystring2_balance(s);
  return res;
}

char mystring2_delete_right(MYSTRING2 *s){
  char res;
  res = mystring_delete_left(&(s->end));
  if(s->end.str_len < 2) mystring2_balance(s);
  return res;
}

int mystring2_count(MYSTRING2 *s, char c[], int len){
  int res = 0;
  static char buf[2000000]; int buf_size, l1, l2;
  static int mem[2000000];

  l1 = mystring_get_right_string(&(s->fst), len-1, buf);
  l2 = mystring_get_right_string(&(s->end), len-1, buf + l1);
  buf_size = l1 + l2;
  charReverse(buf+l1, l2);
  res += KMP(buf, buf_size, c, len, (void*)mem);

  res -= mystring_count(&(s->fst), c, len);
  c[len++] = '~';
  res += mystring_count(&(s->fst), c, len);
  len--;

  charReverse(c, len);
  res -= mystring_count(&(s->end), c, len);
  c[len++] = '~';
  res += mystring_count(&(s->end), c, len);
  len--;
  charReverse(c, len);
  
  return res;
}

void m_set(char a[], int len){
  int i;
  mystring2_set(&s1, a, len/2);
  mystring2_set(&s2, a+len/2, len-len/2);
}

void m_order(void){
  char c;
  int l1, l2;
  while(s1.fst.str_len + s1.end.str_len > s2.fst.str_len + s2.end.str_len){
    c = mystring2_delete_right(&s1);
    mystring2_insert_left(&s2, c);
  }
  while(s1.fst.str_len + s1.end.str_len < s2.fst.str_len + s2.end.str_len - 1){
    c = mystring2_delete_left(&s2);
    mystring2_insert_right(&s1, c);
  }
}

void m_insert_left(char c){
  mystring2_insert_left(&s1, c);
  m_order();
}

void m_insert_middle(char c){
  mystring2_insert_left(&s2, c);
  m_order();
}

void m_insert_right(char c){
  mystring2_insert_right(&s2, c);
  m_order();
}

void m_delete_left(void){
  mystring2_delete_left(&s1);
  m_order();
}

void m_delete_middle(void){
  mystring2_delete_left(&s2);
  m_order();
}

void m_delete_right(void){
  mystring2_delete_right(&s2);
  m_order();
}

int m_query(char str[], int len){
  int res = 0;
  static char buf[2000000]; int buf_size = 0;
  static int mem[2000000];
  
  buf_size += mystring2_get_right_string(&s1, buf, len-1);
  buf_size += mystring2_get_left_string(&s2, buf+buf_size, len-1);
  res += KMP(buf, buf_size, str, len, (void*)mem);

  res += mystring2_count(&s1, str, len);
  res += mystring2_count(&s2, str, len);

  return res;
}

int main(){
  int Q;
  string query;

  int i, j, k;
  static char buf[1700000]; int buf_size;
  int totQ = 0;

  srand(time(NULL));

  buf_size = read_string(buf, 10, 10, '\n');
  Q = read_int(0, 150000, '\n');

  m_set(buf, 10);

  while(Q--){
    buf_size = read_string2(buf, 5, 20);
    query = buf;

    if(query == "INSERT_LEFT"){
      read_string(buf, 1, 1, '\n');
      m_insert_left(buf[0]);
    }else if(query == "INSERT_RIGHT"){
      read_string(buf, 1, 1, '\n');
      m_insert_right(buf[0]);
    }else if(query == "INSERT_MIDDLE"){
      read_string(buf, 1, 1, '\n');
      m_insert_middle(buf[0]);
    }else if(query == "DELETE_LEFT"){
      m_delete_left();
    }else if(query == "DELETE_RIGHT"){
      m_delete_right();
    }else if(query == "DELETE_MIDDLE"){
      m_delete_middle();
    }else if(query == "QUERY"){
      buf_size = read_string(buf, 1, 1700000, '\n');
      totQ += buf_size;
      assert(totQ <= 1500000);
      printf("%d\n",m_query(buf,buf_size));
    }else {
      assert(0);
    }

    assert(s1.fst.str_len + s1.end.str_len + s2.fst.str_len + s2.end.str_len >= 10);
  }

  assert( scanf("%*c")==EOF );
  return 0;
}
